/*
 * Copyright (c) 2015, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should. 
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include 
 * your own code snippet into our standard library please contact us at:
 * http://tasks.strategyquant.com/projects/snippets/
 *
 * This code can be used only within StrategyQuant products. 
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product 
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work 
 * with the StrategyQuant community.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES 
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 */
package com.strategyquant.extend.TradeAnalysisPanes;

import org.jfree.chart.JFreeChart;

import com.strategyquant.lib.charts.common.SQBarChart;
import com.strategyquant.lib.language.L;
import com.strategyquant.lib.results.SQData;
import com.strategyquant.lib.results.SQOrder;
import com.strategyquant.lib.results.SQOrderList;
import com.strategyquant.lib.results.SQResultsGroup;
import com.strategyquant.lib.settings.SQConst;
import com.strategyquant.lib.snippets.TradeAnalysisChartPane;
import com.strategyquant.lib.time.SQTime;

public class WinLossCountByDayChart extends TradeAnalysisChartPane {

	public WinLossCountByDayChart() {
		this.name = L.t("Wins/Losses by day");
	}
	
	@Override
	public JFreeChart drawChart(SQResultsGroup strategyResult, SQData data) {
		SQBarChart chart = new SQBarChart();
		chart.xLegend = L.t("Wins/Losses / Day");
		
		if(strategyResult==null) {
			return chart.render();
		}
		
		int[][] days = computeData(strategyResult, data);
		
		for(int day=0; day<days.length; day++) {
			chart.setValue(days[day][0], "winners", day+1);
			chart.setValue(days[day][1], "losers", day+1);
		}
		
		chart.setIntegerRangeAxis(true);
		
		return chart.render();
	}

	private int[][] computeData(SQResultsGroup strategyResult, SQData data) {
		String plType = data.getString("plType", SQConst.PL_IN_MONEY);
		String tradePeriod = data.getString("tradePeriod", SQConst.TRADE_PERIOD_OPEN_TIME);
		
		SQOrderList orderList = filterOrders(strategyResult, data);
		
		int[][] days = new int[31][2];
		
		for(int day=0; day<days.length; day++) { 
			days[day][0] = 0; //win
			days[day][1] = 0; //loss
		}
		
		SQTime sqTime;
		int day;
		
		for(SQOrder order : orderList) {
			sqTime = new SQTime(order.getTime(tradePeriod));
			day = sqTime.getDay(); //1-31

			if(order.getPL(plType)>0) { //win
				days[day-1][0]+=1; 
			} else { //loss
				days[day-1][1]+=1;
			}
		}
		
		return days;
	}
}